package cn.gzkx.apidemo.config;

import cn.dev33.satoken.context.SaHolder;
import cn.dev33.satoken.filter.SaServletFilter;
import cn.dev33.satoken.interceptor.SaInterceptor;
import cn.dev33.satoken.same.SaSameUtil;
import cn.dev33.satoken.stp.StpUtil;
import cn.dev33.satoken.util.SaResult;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class SaTokenConfigure implements WebMvcConfigurer {
    // 注册 Sa-Token 拦截器，打开注解式鉴权功能
    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        // 注册 Sa-Token 拦截器，打开注解式鉴权功能
//        registry.addInterceptor(new SaInterceptor().setAuth(obj->{
//            StpUtil.checkLogin();
//        })).addPathPatterns("/**");
        registry.addInterceptor(new SaInterceptor()).addPathPatterns("/**");
    }
// 注册 Sa-Token 全局过滤器
//@Bean
//public SaServletFilter getSaServletFilter() {
//    return new SaServletFilter()
//            .addInclude("/**")
//            .addExclude("/favicon.ico")
//            .setAuth(obj -> {
//                // 校验 Same-Token 身份凭证     —— 以下两句代码可简化为：SaSameUtil.checkCurrentRequestToken();
//                String token = SaHolder.getRequest().getHeader("satoken");
//                SaSameUtil.checkToken(token);
//            })
//            .setError(e -> {
//                return SaResult.error(e.getMessage());
//            })
//            ;
//}
}
